----------------------------------------------------------------------
-- Created by SmartDesign Wed Aug 12 08:47:06 2020
-- Version: v12.4 12.900.0.16
----------------------------------------------------------------------

----------------------------------------------------------------------
-- Libraries
----------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

library polarfire;
use polarfire.all;
----------------------------------------------------------------------
-- YCbCr2RGB_IP0 entity declaration
----------------------------------------------------------------------
entity YCbCr2RGB_IP0 is
    -- Port list
    port(
        -- Inputs
        CLOCK_I      : in  std_logic;
        Cb_I         : in  std_logic_vector(7 downto 0);
        Cr_I         : in  std_logic_vector(7 downto 0);
        DATA_VALID_I : in  std_logic;
        RESET_N_I    : in  std_logic;
        Y_I          : in  std_logic_vector(7 downto 0);
        -- Outputs
        BLUE_O       : out std_logic_vector(7 downto 0);
        DATA_VALID_O : out std_logic;
        GREEN_O      : out std_logic_vector(7 downto 0);
        RED_O        : out std_logic_vector(7 downto 0)
        );
end YCbCr2RGB_IP0;
----------------------------------------------------------------------
-- YCbCr2RGB_IP0 architecture body
----------------------------------------------------------------------
architecture RTL of YCbCr2RGB_IP0 is
----------------------------------------------------------------------
-- Component declarations
----------------------------------------------------------------------
-- YCbCr2RGB   -   Microsemi:SolutionCore:YCbCr2RGB:3.0.1
component YCbCr2RGB
    generic( 
        G_RGB_DATA_BIT_WIDTH   : integer := 8 ;
        G_YCbCr_DATA_BIT_WIDTH : integer := 8 
        );
    -- Port list
    port(
        -- Inputs
        CLOCK_I      : in  std_logic;
        Cb_I         : in  std_logic_vector(7 downto 0);
        Cr_I         : in  std_logic_vector(7 downto 0);
        DATA_VALID_I : in  std_logic;
        RESET_N_I    : in  std_logic;
        Y_I          : in  std_logic_vector(7 downto 0);
        -- Outputs
        BLUE_O       : out std_logic_vector(7 downto 0);
        DATA_VALID_O : out std_logic;
        GREEN_O      : out std_logic_vector(7 downto 0);
        RED_O        : out std_logic_vector(7 downto 0)
        );
end component;
----------------------------------------------------------------------
-- Signal declarations
----------------------------------------------------------------------
signal BLUE_O_net_0       : std_logic_vector(7 downto 0);
signal DATA_VALID_O_net_0 : std_logic;
signal GREEN_O_net_0      : std_logic_vector(7 downto 0);
signal RED_O_net_0        : std_logic_vector(7 downto 0);
signal RED_O_net_1        : std_logic_vector(7 downto 0);
signal GREEN_O_net_1      : std_logic_vector(7 downto 0);
signal BLUE_O_net_1       : std_logic_vector(7 downto 0);
signal DATA_VALID_O_net_1 : std_logic;

begin
----------------------------------------------------------------------
-- Top level output port assignments
----------------------------------------------------------------------
 RED_O_net_1         <= RED_O_net_0;
 RED_O(7 downto 0)   <= RED_O_net_1;
 GREEN_O_net_1       <= GREEN_O_net_0;
 GREEN_O(7 downto 0) <= GREEN_O_net_1;
 BLUE_O_net_1        <= BLUE_O_net_0;
 BLUE_O(7 downto 0)  <= BLUE_O_net_1;
 DATA_VALID_O_net_1  <= DATA_VALID_O_net_0;
 DATA_VALID_O        <= DATA_VALID_O_net_1;
----------------------------------------------------------------------
-- Component instances
----------------------------------------------------------------------
-- YCbCr2RGB_IP0_0   -   Microsemi:SolutionCore:YCbCr2RGB:3.0.1
YCbCr2RGB_IP0_0 : YCbCr2RGB
    generic map( 
        G_RGB_DATA_BIT_WIDTH   => ( 8 ),
        G_YCbCr_DATA_BIT_WIDTH => ( 8 )
        )
    port map( 
        -- Inputs
        CLOCK_I      => CLOCK_I,
        RESET_N_I    => RESET_N_I,
        Y_I          => Y_I,
        Cb_I         => Cb_I,
        Cr_I         => Cr_I,
        DATA_VALID_I => DATA_VALID_I,
        -- Outputs
        RED_O        => RED_O_net_0,
        GREEN_O      => GREEN_O_net_0,
        BLUE_O       => BLUE_O_net_0,
        DATA_VALID_O => DATA_VALID_O_net_0 
        );

end RTL;
